////////////////////////////////////////////////////////////////////////
// Resume Session Template v 2.0.3.6
// 2006-12-30 09:52:25
// SiC
////////////////////////////////////////////////////////////////////////
var maxResumeSession = {};
maxResumeSession.pageList = [];
maxResumeSession.autoClose = false;

$langDefaultSection = "ResumeSession";

//----------------------------------------------------------
// Initialization
//----------------------------------------------------------
maxResumeSession.init = function(){

	// Replace page title
	document.title = $lang("title");
	maxResumeSession.loadAutoClose();
	maxResumeSession.loadPageList();
	maxResumeSession.buildPageList();

}


//----------------------------------------------------------
// Load auto close resume page setting
//----------------------------------------------------------
maxResumeSession.loadAutoClose = function(){

	// Data
	maxConfig.setActiveFile("$main");
	var autoClose = maxConfig.ini.getValue("Settings", "ResumeAutoClose");

	autoClose = (autoClose != "1") ? false : true;

	maxResumeSession.autoClose = autoClose;

	// UI Update
	var obj = $id("auto_close");
	if(!obj) return;
	obj.checked = autoClose;

}


//----------------------------------------------------------
// Toggle auto close resume page setting
//----------------------------------------------------------
maxResumeSession.toggleAutoClose = function(){

	var obj = $id("auto_close");

	if(obj.checked){
		maxResumeSession.autoClose = true;
	}else{
		maxResumeSession.autoClose = false;
	}

	maxConfig.setActiveFile("$main");
	maxConfig.ini.setValue("Settings", "ResumeAutoClose", maxResumeSession.autoClose ? "1" : "0");
	maxConfig.save();

}


//----------------------------------------------------------
// Load last visted page list
//----------------------------------------------------------
maxResumeSession.loadPageList = function(){

	maxConfig.setActiveFile("$session");
	var arrList = maxConfig.ini.getArray("LastURL", false);

	for(var i=0; i<arrList.length; i++){
		var item = {};
		item.id = i;
		item.url = arrList[i][0];
		item.title = arrList[i][1];
		item.enabled = true;
		arrList[i] = item;
	}

	maxResumeSession.pageList = arrList;

}


//----------------------------------------------------------
// Build last visted page list
//----------------------------------------------------------
maxResumeSession.buildPageList = function(){

	var objList = $id("pageList");
	if(!objList) alert("maxResumeSession.buildList : can not get obj 'pageList'");

	var output = '';
	for(var i=0; i<maxResumeSession.pageList.length; i++){

		var item = maxResumeSession.pageList[i];
		var url = item.url.$encodeHTML();
		var isLocal = false;

		if(url.indexOf("file://")==0){
			// special treatment for local pages
			isLocal = true;
			url = "javascript:maxResumeSession.openPage("+i+")";
		}
		output +='<div class="pageList-item">' +
			'<img src="../_shared/images/btn_check_checked.png" id="check_' + item.id + '" class="checkButton" onclick="maxResumeSession.togglePageItem(' + item.id + ');" />' +
			'&nbsp; ' +
			'<a id="link_' + item.id + '" href="' + url + '"' +
			(isLocal ? '' : ' target="_blank"') +
			' onclick="javascript:maxResumeSession.linkOpened(\'' + item.id + '\');">' +
				item.title.$cut(100).$encodeHTML() +
			'</a>' +
			'</div>';

	}

	objList.innerHTML = output;

}


//----------------------------------------------------------
// Toggle last visted page item
//----------------------------------------------------------
maxResumeSession.togglePageItem = function(id){

	if(!maxResumeSession.pageList[id]){
		alert("maxResumeSession.togglePageItem :: invalid id " + id);
		return;
	}

	var item = maxResumeSession.pageList[id];

	item.enabled = !item.enabled;

	maxResumeSession.updatePageItemCheck(item);

}


//----------------------------------------------------------
// Update last visted page item checkbox
//----------------------------------------------------------
maxResumeSession.updatePageItemCheck = function(item){

	var objImg = $id("check_" + item.id);
	if(!objImg){
		alert("maxResumeSession.updatePageItemCheck : invalid id " + id);
		return;
	}

	if(item.enabled){
		objImg.src = "../_shared/images/btn_check_checked.png";
	}else{
		objImg.src = "../_shared/images/btn_check.png";
	}

}


//----------------------------------------------------------
// Select pages - 1: select all, 0: select none, -1: invert
//----------------------------------------------------------
maxResumeSession.selectPages = function(method){

	for(var i=0; i<maxResumeSession.pageList.length; i++){

		var item = maxResumeSession.pageList[i];
		if(method == 1){
			item.enabled = true;
		}else if(method == 0){
			item.enabled = false;
		}else{
			item.enabled = !item.enabled;
		}

		maxResumeSession.updatePageItemCheck(item);

	}

}


//----------------------------------------------------------
// Open given page
//----------------------------------------------------------
maxResumeSession.openPage = function(index){
	
	var item = maxResumeSession.pageList[index];
	if(!item) return;

	try{
		external.max_newTab('', item.url,"ignoreOpenNext;DelCurrentSession;");
	}catch(e){
		window.open(item.url);
	}

	item.enabled=false;
	item.opened=true;

	maxResumeSession.updatePageItemCheck(item);
	maxResumeSession.updatePageItemStatus(item);

}


//----------------------------------------------------------
// Open selected pages
//----------------------------------------------------------
maxResumeSession.openPages = function(){

	for(var i=0; i<maxResumeSession.pageList.length; i++){
		if(maxResumeSession.pageList[i].enabled){
			maxResumeSession.openPage(i);
		}
	}

	if(maxResumeSession.autoClose) external.max_closeTab('');

}


//----------------------------------------------------------
// Update last visted page item status to opened
//----------------------------------------------------------
maxResumeSession.updatePageItemStatus = function(item){

	var objA = $id("link_" + item.id);
	if(!objA){
		alert("maxResumeSession.updatePageItemStatus : invalid id " + item.id);
		return;
	}

	objA.className = "openedPageLink";

}


//----------------------------------------------------------
// Set a flag to mark a link is opened
//----------------------------------------------------------
maxResumeSession.linkOpened = function(id){

	if(!maxResumeSession.pageList[id]){
		alert("maxResumeSession.togglePageItem : invalid id " + id);
		return;
	}

	var item = maxResumeSession.pageList[id];

	item.enabled = false;
	item.opened = true;
	maxResumeSession.updatePageItemCheck(item);

	try{
		external.max_invoke("DelCurrentSession", item.url);
	}catch(e){}

}
